﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Globalization;
using System.Windows;

namespace XDGFieldDecToHex
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private State curState = State.dec;

        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }

        private void xdg_EditModeEnding(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndingEventArgs e)
        {
            string newValue = e.Editor.Value.ToString();
            if (curState == State.dec)
            {
                UInt32 res;
                if (!UInt32.TryParse(newValue, out res))
                {
                    e.AcceptChanges = false;
                    MessageBox.Show("Value exceeds valid UInt32 range");
                }
                else
                {
                    // persist data or else
                }
            }
            else
            {
                uint res;
                if (!UInt32.TryParse(newValue.Substring(2), System.Globalization.NumberStyles.HexNumber, CultureInfo.CurrentCulture, out res))
                {
                    e.AcceptChanges = false;
                    MessageBox.Show("Value exceeds valid UInt32 range");
                }
                else
                {
                    // persist data or else
                }
            }
        }


        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (curState == State.dec)
            {
                foreach (var rec in this.xdg.Records)
                {
                    DataRecord dr = rec as DataRecord;

                    UInt32 res;
                    if (!UInt32.TryParse(dr.Cells[1].Value.ToString(), out res))
                    {
                        MessageBox.Show("Value exceeds valid UInt32 range");
                    }
                    else
                    {
                        dr.Cells[1].Value = "0x" + res.ToString("X");
                    }

                }
                curState = State.hex;
            }
            else
            {
                foreach (var rec in this.xdg.Records)
                {
                    DataRecord dr = rec as DataRecord;
                    uint res;
                    if (!UInt32.TryParse(dr.Cells[1].Value.ToString().Substring(2), System.Globalization.NumberStyles.HexNumber, CultureInfo.CurrentCulture, out res))
                    {
                        MessageBox.Show("Value exceeds valid UInt32 range");
                    }
                    else
                    {
                        // persist data or else
                        dr.Cells[1].Value = res.ToString();
                    }

                }
                curState = State.dec;
            }
        }
    }


    public enum State
    {
        dec,
        hex
    }
}
