﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace XDGFieldDecToHex
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        Random r = new Random();
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for (int i = 0; i < 10; i++)
            {
                SampleData sd = new SampleData()
                {
                    ID = i,
                    Number = r.Next(1000).ToString()
                };

                this.Data.Add(sd);
            }
        }
    }

    public class SampleData : ObservableModel
    {
        private int _id;
        public int ID
        {
            get { return _id; }
            set
            {
                _id = value;
                OnPropertyChanged();
            }

        }

        private string _number;

        public string Number
        {
            get { return _number.ToString(); }
            set
            {
                _number = value;
                OnPropertyChanged();
            }

        }

    }


    public class ObservableModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged([CallerMemberName] string name = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(name));
        }
    }
}
